package Agent::6020;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>

#  $Name:  $ 
#  $Id: 6020.pm,v 1.4 2003/12/17 02:47:39 edunning Exp $

use Catalog;
use strict;
use State;
use Report;
use Agent;
use Agent::6120;
use Data::Dumper;
use base 'Agent::6120';
use Timer;


sub isSelectable { "Sun 6020"}
sub revision     { '$Revision: 1.4 $'}
sub type         { Report::CAT_6020 }
sub diskTotal    { 14   }

# do not remove this comment
# Report::CAT_T3MESSAGE

use vars qw(%N2IP $ERR);

sub new {
  my($self) = Agent->new();

  bless ($self, 'Agent::6020');
  return $self;
}

sub removeCores{
  my($class, $rep, $device) = @_;

  my $renv   = System->get_renv();
  my $telnet = $class->getPassword($device);
  my $UNITCNT = $rep->{'unit.count'} || $rep->{'controller.count'};
  my $DISKCNT = $rep->{'disk.count'} || 14;

  #To upload core file:
  #http://<array name>/update?unitIndex=0&fruIndex=0&coreTftp=Apply
  #To remove core file:
  #http://<array name>/update?unitIndex=0&fruIndex=0&coreRemove=Apply 

  my ($unit, $disk);
  for ($unit = 1; $unit <= $UNITCNT; $unit++) {
    for ($disk = 1; $disk <= $DISKCNT; $disk++) {
      my $diskid = $disk-1;
      my $unitid = $unit-1;
      if ($rep->{"disk.u${unit}d${disk}.coreDesc"}) {
        Debug->print2("Found Core File on u$unit"."d$disk");
        Debug->print2("Pushing Core to Host and removing it from Array");
        Debug->print2("\tCore Description:\n".
                      $rep->{"disk.u${unit}d${disk}.coreDesc"});
        my $command="update?unitIndex=$unitid&fruIndex=$diskid&coreTftp=Apply";
        my $url = "http://$device->{ipno}/$command";
        my($err,$out) = Util::Http->get($url,2,{password => "root:$telnet"});
        if ($err) {
          Debug->errNoRepeat(COREPUSH => $device->{ipno}, 8, $err);
        } 
        my $command="update?unitIndex=$unitid&fruIndex=$diskid".
                    "&coreRemove=Apply";
        my $url = "http://$device->{ipno}/$command";
        my($err,$out) = Util::Http->get($url,2,{password => "root:$telnet"});
        if ($err) {
          Debug->errNoRepeat(COREREMOVE => $device->{ipno}, 8, $err);
        } 

      }
    }
  }
}


1;
