package GUI::Sched;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>

use System;
use Util;
use Scheduler;

use Cache;

sub line {
  my($pid, $host, $err, $end) = @_;
  my $status;
  if ($err) {
    $status = "<font color=red>ERR";
  } elsif (!$end) {
    $status = "<font color=blue>Running";
  } else {
    $status = "<font color=green>OK";
  }
   
  my $url = "<a href=\"javascript:win1('$pid','$host')\">$pid</a>";
  return ($status, $url);
}

sub list {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs);


  if ($q->{ACTION} eq "DeleteAll") {
    opendir(O, System->get_home() . "/DATA/Proc");
    my @f = readdir(O); closedir(O);
    foreach my $file (@f) {
       next if (substr($file ,0,1) eq ".");
       unlink(System->get_home() . "/DATA/Proc/$file");
    }
    ($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read();
    foreach $h (@$hosts) {
    }
      
  } elsif ($q->{ACTION} eq "DeleteSelected") {
    foreach my $v (keys %$q) {
       if (substr($v,0,10) eq "del_local_") {
          my $pid = substr($v,10);
          Scheduler->delete($pid, "");
       } else {
          my (@x) = split(/_/, $v);
          Scheduler->delete($x[2], $x[1]);
       }
    }

  } elsif ($q->{ACTION} eq "Run") {
    my $ix = index($q->{command}, " ");
    if ($ix > 0) {
       $command = substr($q->{command},0,$ix);
       $opts = substr($q->{command},$ix+1);
    } else {
       $command = $q->{command};
    }
    my $h = ($q->{host} eq "local") ? undef: $q->{host};

    my $pid = Scheduler->run($h, $command, $opts, 10);
    print "<b>Process $pid ($command) started!";
  }
  
  print "
 <body bgcolor=#F0F0F0>&nbsp;
<script>
function win1(a,b) {
  var b = '$Http::WEBPROC?GO=GUI::Sched::display&pid=' + a + '&host=' + b;
  var O = window.open(b,'Fav','menubar=no,resizable=yes,scrollbars=yes,width=400,height=500');
  O.focus();
}
</script>
         <form><input type=hidden name=GO value=GUI::Sched::list>";
  print "<table border=1 cellspacing=0 width=100% bgcolor=white>
  <tr><td colspan=2 nowrap><b><center>
      <input type=submit name=ACTION value=List></td>
      <td colspan=5><b>
      &nbsp;Command: <input type=text name=command size=30>&nbsp;
      Host: <select name=host>$sel</select>
      <input type=submit name=ACTION value=Run>
  <tr bgcolor=$Style::LIGHT>
    <td><b>Host
    <td><b>Process
    <td><b>Command
    <td><b><center>Status
    <td><b>Start
    <td><b>End
    <td><center><b>Delete
  ";

  $local = Scheduler->processList();
  my $cnt = 0;
  my $running = 0;
  foreach $l (@$local) {
     my($pid, $comm, $arg, $host, $start, $end, $err) = split(/\t/, $l);
     my($status, $url) = &line($pid, "local", $err, $end);
     $running = 1 if ($status =~ /Running/);
     my $del = "<input type=checkbox name=del_local_$pid>";
     $cnt++;
     print "<tr><td>local<td>$url<td>$comm $arg<td><center><b>$status".
           "<td>$start<td>$end&nbsp;</td><td><center>$del</td>";
  }

  foreach $h (@$hosts) {
     $remote = Scheduler->processList($h->{hostname});
     foreach $l (@$remote) {
        my($pid, $comm, $arg, $host, $start, $end, $err) = split(/\t/, $l);
        my $sh = Util->shortHostname($host);
        my($status, $url) = &line($pid, $host, $err, $end);
        $running = 1 if ($status =~ /Running/);
        my $del = "<input type=checkbox name=del_${host}_$pid>";
        $cnt++;
        print "<tr><td>$sh<td>$url<td>$comm $arg<td><status><center><b>$status<td>$start</td>
          <td>$end&nbsp;<td><center>$del</td>";
     }
  }
  if (!$cnt) {
   print "<tr><td colspan=7>&nbsp;<br><b>Scheduler is empty!</td>";
  }
  if ($running) {
    print "<meta http-equiv=Refresh content=\"10;URL=$Http::WEBPROC?GO=GUI::Sched::list\">";
  }

  print "</table>
  <table border=0 width=100%>
  <tr><td colspan=7 align=right>
   <b><input type=submit name=ACTION value=DeleteAll>&nbsp;
   <input type=submit name=ACTION value=DeleteSelected></form>
  </table>
  ";
  
}

#pid | command | arg | host | start | end | err

sub display {
  my($q) = @_;
  my(@p1, @p2, @a, @out);
  print "\n<body bgcolor=#F0F0F0>&nbsp;";
 
  my $h = ($q->{host} eq "local")? undef: $q->{host};

  my($p1, $out, $err) = Scheduler->read($h, $q->{pid});

  my $err0 = "<font color=red>Error:</font>" if ($#$err >= 0);

  my $scr = Html::Screen->new();
  $scr->table( { title => "Process Details" },
   [
   [ f => 'Process' , "$p1->[1] $p1->[2]" ],
   [ f => 'StartTime', $p1->[4] ],
   [ f => 'EndTime',   $p1->[5] ],
   ]);
  $scr->add("<pre>$err0 @$err @$out");

  print $scr->out();

  
}
    
  

1;
